import 'dart:typed_data';

nextPermutation(c) {
  nSwaps=0;
  // 1. finds the largest k, that c[k] < c[k+1]
  int first = getFirst( c );
  if ( first == -1 ) {
    print("    case $minorCount:");
    print("      nextSlow();");
    print("      minorCount =-1;");
    print("      break;");
    return null; // no greater permutation
  }
  
  print("    case $minorCount:");

  // 2. find last index toSwap, that c[k] < c[toSwap]
  int toSwap = c.length - 1;
  while ( c[ first ] >= c[ toSwap ] )
    --toSwap;
  // 3. swap elements with indexes first and last
  swap( c, first++, toSwap ); nSwaps++;
  // 4. reverse sequence from k+1 to n (inclusive) 
  toSwap = c.length - 1;
  while ( first < toSwap ) {
    swap( c, first++, toSwap-- );
    nSwaps++;
  }  
  if ((nSwaps&1)!=0)
    print("      parity^=1;"); 
  print("      break;");
  minorCount++;
  parity^=(nSwaps&1);
  return c;
}

// finds the largest k, that c[k] < c[k+1]
// if no such k exists (there is not greater permutation), return -1
int getFirst(c) {
  for ( int i = c.length - 2; i >= 0; --i )
    if ( c[i] < c[i+1] )
      return i;
  return -1;
}

// swaps two elements (with indexes i and j) in array 
void swap( c, final int i, final int j ) {
  int tmp = c[ i ];
  c[ i ] = c[ j ];
  c[ j ] = tmp;
  print("      save$i = c[base+$i]; c[base+$i]=c[base+$j]; c[base+$j]=save$i;");
}
printSwap(int i, int j) {
  
}
printPermutation(c) {
   //print("${c.join(",")} $nSwaps");
}
int nSwaps=0;
int minorCount=0;
int parity=0;
printPrologue() {
  print("  static const int _generatedLength=$generatedLength;");
  print("  bool next() {");
  print("    int save0, save1, save2;");
  print("    var c = _list;");
  print("    if (_count==0) { _count=1; return true;}");
  print("    if (_count==_total) return false;");
  
  print("    switch(_minorCount) {");
}
printEpilogue() {
  print("    }");
  print("    _minorCount++; _count++;");
  print("    return true;");
  print("  }");
}
var generatedLength=3;
main() {
   printPrologue();
   var c= new Uint8List(generatedLength);
   for (int i=0; i<c.length; i++)
     c[i]=i+1;
   
   do {
     c=nextPermutation(c);
     
   } while (c!=null);
   printEpilogue();
   
}