import '../permutizr.dart';
main(args) {
  const N=10;
  var p1=new Permutizr(N), p2=new Permutizr(N);
  int count=0;
  while(p1.next()) {
    count++;
    p2.nextSlow();
    compare(p1.list, p2.list);  
  }
  print("all $count permutations match");
  perfTest();
  perfTestSlow();
}
compare(list1, list2) {
  if (list1.length!=list2.length)
    throw ("different length $list1 $list2");
  for (int i=0; i<list1.length; i++) {
     if (list1[i]!=list2[i])
       throw ("lists are different $list1 $list2");
  }   
}
perfTest() {
  var sw=new Stopwatch()..start();
  var p1=new Permutizr(11);
  int count=0;
  while(p1.next()) {
    count++;
  }
  print("FAST: total $count iterations, perf=${sw.elapsedMicroseconds*1000.0/count} ns/iteration");
}
perfTestSlow() {
  var sw=new Stopwatch()..start();
  var p1=new Permutizr(11);
  int count=0;
  while(p1.nextSlow()) {
    count++;
  }
  print("SLOW: total $count iterations, perf=${sw.elapsedMicroseconds*1000.0/count} ns/iteration");
}
